(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('simple-mask-money'), require('currency-symbol-map/map'), require('@douglas-serena/calc.js'), require('imask'), require('@angular/common'), require('dayjs')) :
    typeof define === 'function' && define.amd ? define('@douglas-serena/ng-inputs-bootstrap', ['exports', '@angular/core', '@angular/forms', 'simple-mask-money', 'currency-symbol-map/map', '@douglas-serena/calc.js', 'imask', '@angular/common', 'dayjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['douglas-serena'] = global['douglas-serena'] || {}, global['douglas-serena']['ng-inputs-bootstrap'] = {}), global.ng.core, global.ng.forms, global.SimpleMaskMoney, global.currencyToSymbolMap, global.calcJs, global.IMask, global.ng.common, global.dayjs));
}(this, (function (exports, i0, forms, SimpleMaskMoney, currencyToSymbolMap, calcJs, IMask, common, dayjs) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var SimpleMaskMoney__default = /*#__PURE__*/_interopDefaultLegacy(SimpleMaskMoney);
    var currencyToSymbolMap__default = /*#__PURE__*/_interopDefaultLegacy(currencyToSymbolMap);
    var calcJs__default = /*#__PURE__*/_interopDefaultLegacy(calcJs);
    var IMask__default = /*#__PURE__*/_interopDefaultLegacy(IMask);
    var dayjs__namespace = /*#__PURE__*/_interopNamespace(dayjs);

    var NgConfigService = /** @class */ (function () {
        function NgConfigService() {
            this._config = {
                global: {
                    select: {},
                    textArea: {},
                    autocomplete: {
                        icon: {
                            loading: {
                                class: 'fas fa-spinner ng-loading',
                            },
                            left: {
                                class: 'fas fa-search',
                            },
                        },
                    },
                    input: {
                        types: {
                            password: {
                                icon: {
                                    right: {
                                        class: 'fas fa-eye',
                                        click: function (_, input, icon) {
                                            if (input.type === 'password') {
                                                icon.class = 'fas fa-eye-slash';
                                                input.type = 'text';
                                            }
                                            else {
                                                icon.class = 'fas fa-eye';
                                                input.type = 'password';
                                            }
                                        },
                                    },
                                },
                            },
                        },
                    },
                },
            };
        }
        Object.defineProperty(NgConfigService.prototype, "global", {
            get: function () {
                return this.config.global;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "input", {
            get: function () {
                var _a;
                return (_a = this.global) === null || _a === void 0 ? void 0 : _a.input;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "select", {
            get: function () {
                var _a;
                return (_a = this.global) === null || _a === void 0 ? void 0 : _a.select;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "textarea", {
            get: function () {
                var _a;
                return (_a = this.global) === null || _a === void 0 ? void 0 : _a.textArea;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "autocomplete", {
            get: function () {
                var _a;
                return (_a = this.global) === null || _a === void 0 ? void 0 : _a.autocomplete;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "config", {
            get: function () {
                return this._config;
            },
            set: function (value) {
                Object.assign(this._config, value);
            },
            enumerable: false,
            configurable: true
        });
        NgConfigService.prototype.types = function (field) {
            var _a, _b;
            return (_b = (_a = this.global) === null || _a === void 0 ? void 0 : _a[field]) === null || _b === void 0 ? void 0 : _b.types;
        };
        Object.defineProperty(NgConfigService.prototype, "typesSelect", {
            get: function () {
                return this.types('select');
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "typesInput", {
            get: function () {
                return this.types('input');
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "typesTextArea", {
            get: function () {
                return this.types('textArea');
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "typesAutocompleta", {
            get: function () {
                return this.types('autocompleta');
            },
            enumerable: false,
            configurable: true
        });
        return NgConfigService;
    }());
    NgConfigService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgConfigService_Factory() { return new NgConfigService(); }, token: NgConfigService, providedIn: "root" });
    NgConfigService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];

    var NgConfigModule = /** @class */ (function () {
        function NgConfigModule() {
        }
        NgConfigModule.forRoot = function () {
            return {
                ngModule: NgConfigModule,
                providers: [NgConfigService],
            };
        };
        return NgConfigModule;
    }());
    NgConfigModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [],
                    exports: [],
                    providers: [NgConfigService],
                },] }
    ];

    var NgInputsBootstrap = /** @class */ (function () {
        function NgInputsBootstrap() {
        }
        NgInputsBootstrap.forRoot = function (options) {
            return {
                ngModule: NgInputsBootstrap,
                providers: [
                    NgConfigService,
                    {
                        provide: FOR_ROOT_OPTIONS_TOKEN,
                        useValue: options,
                    },
                    {
                        provide: NgConfigService,
                        useFactory: provideMyServiceOptions,
                        deps: [FOR_ROOT_OPTIONS_TOKEN],
                    },
                ],
            };
        };
        return NgInputsBootstrap;
    }());
    NgInputsBootstrap.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [NgConfigModule],
                },] }
    ];
    var FOR_ROOT_OPTIONS_TOKEN = new i0.InjectionToken('forRoot() NgConfigService() configuration.');
    function provideMyServiceOptions(configs) {
        var service = new NgConfigService();
        if (configs) {
            service.config = configs;
        }
        return service;
    }

    var NgColumnsDirective = /** @class */ (function () {
        function NgColumnsDirective(elementRef, renderer2) {
            this.elementRef = elementRef;
            this.renderer2 = renderer2;
            this._columns = {
                addParent: false,
                default: 12,
                sm: 12,
            };
            this.theme = 'bootstrap';
        }
        Object.defineProperty(NgColumnsDirective.prototype, "columns", {
            set: function (columns) {
                if (!(typeof columns === 'string')) {
                    Object.assign(this._columns, columns);
                    if (this._element) {
                        this.updateColumns();
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        NgColumnsDirective.prototype.ngOnInit = function () {
            this._element = this.elementRef.nativeElement;
            this.updateColumns();
        };
        NgColumnsDirective.prototype.updateColumns = function () {
            var element = this._element;
            if (this._columns.addParent) {
                if (element.parentElement) {
                    element = element.parentElement;
                }
            }
            if (this.theme === 'materialize') {
                this.renderer2.addClass(element, 'col');
                this.renderer2.addClass(element, "s" + this._columns.sm);
                if (this._columns.md) {
                    this.renderer2.addClass(element, "m" + this._columns.md);
                }
                if (this._columns.lg) {
                    this.renderer2.addClass(element, "l" + this._columns.lg);
                }
                if (this._columns.xl) {
                    this.renderer2.addClass(element, "xl" + this._columns.xl);
                }
            }
            else if (this.theme === 'bootstrap') {
                this.renderer2.addClass(element, "col-" + this._columns.default);
                this.renderer2.addClass(element, "col-sm-" + this._columns.sm);
                if (this._columns.md) {
                    this.renderer2.addClass(element, "col-md-" + this._columns.md);
                }
                if (this._columns.lg) {
                    this.renderer2.addClass(element, "col-lg-" + this._columns.lg);
                }
                if (this._columns.xl) {
                    this.renderer2.addClass(element, "col-xl-" + this._columns.xl);
                }
            }
        };
        return NgColumnsDirective;
    }());
    NgColumnsDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[columns]',
                },] }
    ];
    NgColumnsDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 }
    ]; };
    NgColumnsDirective.propDecorators = {
        theme: [{ type: i0.Input }],
        columns: [{ type: i0.Input }]
    };

    var NgUtilsDirectiveModule = /** @class */ (function () {
        function NgUtilsDirectiveModule() {
        }
        NgUtilsDirectiveModule.forRoot = function () {
            return {
                ngModule: NgUtilsDirectiveModule,
                providers: [],
            };
        };
        return NgUtilsDirectiveModule;
    }());
    NgUtilsDirectiveModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [NgColumnsDirective],
                    exports: [NgColumnsDirective],
                },] }
    ];

    var PROVIDER_VALUE_ACCESSOR$9 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgMaskAmountDirective; }),
        multi: true,
    };
    var NgMaskAmountDirective = /** @class */ (function () {
        function NgMaskAmountDirective(elementRef, renderer2, changeDetectorRef) {
            var _this = this;
            this.elementRef = elementRef;
            this.renderer2 = renderer2;
            this.changeDetectorRef = changeDetectorRef;
            this._isAmount = false;
            this._config = {
                allowNegative: true,
                fractionDigits: 3,
                decimalSeparator: ',',
                align: 'right',
                validator: true,
                focusSelectText: true,
            };
            this.type = 'text';
            this.value = new i0.EventEmitter();
            this.onTouched = function () { };
            this.onFocus = function () {
                var _a;
                if (((_a = _this._config) === null || _a === void 0 ? void 0 : _a.focusSelectText) && _this._isAmount) {
                    var length = _this._inputRef.value.length;
                    _this._inputRef.setSelectionRange(0, length);
                }
            };
            this.eventTime = 0;
            this.onChange = function (_) { };
            this.registerOnTouched = function (fn) { return (_this.onTouched = fn); };
            this.setDisabledState = function (isDisabled) { };
            this.registerOnChange = function (fn) {
                _this.onChange = fn;
                if (_this._isAmount) {
                    _this.onInput();
                }
            };
            this._inputRef = this.elementRef.nativeElement;
        }
        Object.defineProperty(NgMaskAmountDirective.prototype, "ngMaskAmount", {
            set: function (config) {
                if (!(typeof config === 'string')) {
                    Object.assign(this._config, config);
                }
            },
            enumerable: false,
            configurable: true
        });
        NgMaskAmountDirective.prototype.ngOnInit = function () {
            var _this = this;
            if (this.type === 'amount') {
                this.renderer2.setAttribute(this._inputRef, 'type', 'text');
                this.renderer2.setStyle(this._inputRef, 'text-align', this._config.align);
                this._isAmount = true;
                this.createMask();
                this.renderer2.listen(this._inputRef, 'input', function (event) { return _this.onInput(event); });
            }
        };
        NgMaskAmountDirective.prototype.createMask = function () {
            this.onInput();
        };
        NgMaskAmountDirective.prototype.formatAmount = function (value, data) {
            var negative = data === '-';
            value = value.toString();
            if (/^0/g.test(value)) {
                value = value.replace(/0+/, '');
            }
            if (new RegExp(this._config.decimalSeparator, 'g').test(value)) {
                value = value.replace(this._config.decimalSeparator, '.');
            }
            if (value.match('-')) {
                negative = true;
            }
            if (data === undefined) {
                value = Number.parseFloat(value)
                    .toFixed(this._config.fractionDigits)
                    .toString();
            }
            value = value.replace(/\D/g, '');
            value =
                Number.parseFloat(value) /
                    Math.pow(10, this._config.fractionDigits);
            if (Number.isNaN(value)) {
                value = 0;
            }
            if (negative && this._config.allowNegative) {
                value = -value;
            }
            value = value.toFixed(this._config.fractionDigits);
            var valueFormat = value.toString();
            value = Number.parseFloat(value);
            valueFormat = valueFormat.replace('.', this._config.decimalSeparator);
            return { valueFormat: valueFormat, value: value };
        };
        NgMaskAmountDirective.prototype.onInput = function (value) {
            var _this = this;
            if (value === void 0) { value = this._inputRef.value; }
            var valueAmount;
            if (value instanceof InputEvent) {
                var event = value;
                value = event.target.value;
                valueAmount = this.formatAmount(value, event.data);
            }
            else {
                valueAmount = this.formatAmount(value);
            }
            this._inputRef.value = valueAmount.valueFormat;
            var length = this._inputRef.value.length;
            this._inputRef.setSelectionRange(length, length);
            value = this.validRequired(valueAmount.value);
            this.onChange(value);
            this.changeDetectorRef.detectChanges();
            clearTimeout(this.eventTime);
            this.eventTime = setTimeout(function () {
                _this.value.emit(value);
            });
        };
        NgMaskAmountDirective.prototype.validRequired = function (value) {
            if (this._config.validator) {
                if (typeof value === 'string') {
                    return value.length === 0 ? null : value;
                }
                else if (typeof value === 'number') {
                    return value === 0 ? null : value;
                }
            }
            return value;
        };
        NgMaskAmountDirective.prototype.writeValue = function (value) {
            if (this._isAmount) {
                this.onInput(value);
            }
            else {
                this._inputRef.value = value.toString();
            }
        };
        return NgMaskAmountDirective;
    }());
    NgMaskAmountDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[ngMaskAmount]',
                    providers: [PROVIDER_VALUE_ACCESSOR$9],
                },] }
    ];
    NgMaskAmountDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 },
        { type: i0.ChangeDetectorRef }
    ]; };
    NgMaskAmountDirective.propDecorators = {
        ngMaskAmount: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        value: [{ type: i0.Output }],
        onTouched: [{ type: i0.HostListener, args: ['blur', ['$event.target'],] }],
        onFocus: [{ type: i0.HostListener, args: ['focus', ['$event.target'],] }]
    };

    var PROVIDER_VALUE_ACCESSOR$8 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgMaskCurrencyDirective; }),
        multi: true,
    };
    var NgMaskCurrencyDirective = /** @class */ (function () {
        function NgMaskCurrencyDirective(elementRef, renderer2, changeDetectorRef) {
            var _this = this;
            this.elementRef = elementRef;
            this.renderer2 = renderer2;
            this.changeDetectorRef = changeDetectorRef;
            this._locale = currencyToSymbolMap__default['default'].BRL;
            this._isCurrency = false;
            this._config = {
                allowNegative: true,
                negativeSignAfter: false,
                prefix: this._locale,
                suffix: '',
                fixed: true,
                fractionDigits: 2,
                decimalSeparator: ',',
                thousandsSeparator: '.',
                align: 'right',
                cursor: 'end',
                validator: true,
                focusSelectText: true,
            };
            this.type = 'text';
            this.value = new i0.EventEmitter();
            this.onTouched = function () { };
            this.onFocus = function () {
                if (_this._config.focusSelectText && _this._isCurrency) {
                    var length = _this._inputRef.value.length;
                    _this._inputRef.setSelectionRange(0, length);
                }
            };
            this.eventTime = 0;
            this.onChange = function (_) { };
            this.registerOnTouched = function (fn) { return (_this.onTouched = fn); };
            this.setDisabledState = function (isDisabled) { };
            this.registerOnChange = function (fn) {
                _this.onChange = fn;
                if (_this._isCurrency) {
                    _this.onInput();
                }
            };
            this._inputRef = this.elementRef.nativeElement;
        }
        Object.defineProperty(NgMaskCurrencyDirective.prototype, "locale", {
            set: function (symbolOrLocale) {
                if (typeof symbolOrLocale === 'string') {
                    if (currencyToSymbolMap__default['default'][symbolOrLocale] !== undefined) {
                        this._config.prefix = currencyToSymbolMap__default['default'][symbolOrLocale];
                    }
                    else {
                        console.warn('[NG-FIELD] We were unable to locate this currency');
                    }
                }
                else {
                    this._config.prefix = currencyToSymbolMap__default['default'][symbolOrLocale.currency];
                }
                if (this._instanceSimpleMaskMoneyRef === undefined) {
                    this.createMask();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgMaskCurrencyDirective.prototype, "ngMaskCurrency", {
            set: function (config) {
                if (!(typeof config === 'string')) {
                    Object.assign(this._config, config);
                }
            },
            enumerable: false,
            configurable: true
        });
        NgMaskCurrencyDirective.prototype.ngOnInit = function () {
            var _this = this;
            if (this.type === 'currency') {
                this.renderer2.setAttribute(this._inputRef, 'type', 'text');
                this.renderer2.setStyle(this._inputRef, 'text-align', this._config.align);
                this._isCurrency = true;
                this.createMask();
                this.renderer2.listen(this._inputRef, 'input', function (event) { return _this.onInput(event); });
            }
        };
        NgMaskCurrencyDirective.prototype.createMask = function () {
            this._instanceSimpleMaskMoneyRef = SimpleMaskMoney__default['default'].setMask(this._inputRef, this._config);
            this.changeDetectorRef.detectChanges();
        };
        NgMaskCurrencyDirective.prototype.onInput = function (event) {
            var _this = this;
            if (this._instanceSimpleMaskMoneyRef) {
                var value_1 = this.validRequired(this._instanceSimpleMaskMoneyRef.formatToNumber());
                this.onChange(value_1);
                this.changeDetectorRef.detectChanges();
                clearTimeout(this.eventTime);
                this.eventTime = setTimeout(function () {
                    _this.value.emit(value_1);
                });
            }
        };
        NgMaskCurrencyDirective.prototype.validRequired = function (value) {
            if (this._config.validator) {
                if (typeof value === 'string') {
                    return value.length === 0 ? null : value;
                }
                else if (typeof value === 'number') {
                    return value === 0 ? null : value;
                }
            }
            return value;
        };
        NgMaskCurrencyDirective.prototype.writeValue = function (value) {
            if (this._isCurrency) {
                value = value.toString();
                value = value.replace(',', '.');
                value = calcJs__default['default'](value).value.toString();
                value = value.replace('.', this._config.decimalSeparator);
                this._inputRef.value = SimpleMaskMoney__default['default'].formatToCurrency(value, Object.assign(Object.assign({}, this._config), { allowNegative: false }));
                this.onInput();
            }
            else {
                this._inputRef.value = value.toString();
            }
        };
        return NgMaskCurrencyDirective;
    }());
    NgMaskCurrencyDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[ngMaskCurrency]',
                    providers: [PROVIDER_VALUE_ACCESSOR$8],
                },] }
    ];
    NgMaskCurrencyDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 },
        { type: i0.ChangeDetectorRef }
    ]; };
    NgMaskCurrencyDirective.propDecorators = {
        locale: [{ type: i0.Input }],
        ngMaskCurrency: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        value: [{ type: i0.Output }],
        onTouched: [{ type: i0.HostListener, args: ['blur', ['$event.target'],] }],
        onFocus: [{ type: i0.HostListener, args: ['focus', ['$event.target'],] }]
    };

    var PROVIDER_VALUE_ACCESSOR$7 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgMaskPercentDirective; }),
        multi: true,
    };
    var NgMaskPercentDirective = /** @class */ (function () {
        function NgMaskPercentDirective(elementRef, renderer2, changeDetectorRef) {
            var _this = this;
            this.elementRef = elementRef;
            this.renderer2 = renderer2;
            this.changeDetectorRef = changeDetectorRef;
            this._isPercent = false;
            this._config = {
                allowNegative: false,
                negativeSignAfter: false,
                prefix: '',
                suffix: '%',
                fixed: true,
                fractionDigits: 2,
                decimalSeparator: ',',
                thousandsSeparator: '',
                align: 'right',
                cursor: 'end',
                validator: true,
                focusSelectText: true,
            };
            this.type = 'text';
            this.value = new i0.EventEmitter();
            this.onTouched = function () { };
            this.onFocus = function () {
                if (_this._config.focusSelectText && _this._isPercent) {
                    var length = _this._inputRef.value.length;
                    _this._inputRef.setSelectionRange(0, length);
                }
            };
            this.eventTime = 0;
            this.onChange = function (_) { };
            this.registerOnTouched = function (fn) { return (_this.onTouched = fn); };
            this.setDisabledState = function (isDisabled) { };
            this.registerOnChange = function (fn) {
                _this.onChange = fn;
                if (_this._isPercent) {
                    _this.onInput();
                }
            };
            this._inputRef = this.elementRef.nativeElement;
        }
        Object.defineProperty(NgMaskPercentDirective.prototype, "ngMaskPercent", {
            set: function (config) {
                if (!(typeof config === 'string')) {
                    Object.assign(this._config, config);
                }
            },
            enumerable: false,
            configurable: true
        });
        NgMaskPercentDirective.prototype.ngOnInit = function () {
            var _this = this;
            if (this.type === 'percent') {
                this.renderer2.setAttribute(this._inputRef, 'type', 'text');
                this.renderer2.setStyle(this._inputRef, 'text-align', this._config.align);
                this._isPercent = true;
                this.createMask();
                this.renderer2.listen(this._inputRef, 'input', function (event) { return _this.onInput(event); });
            }
        };
        NgMaskPercentDirective.prototype.createMask = function () {
            this._instanceSimpleMaskMoneyRef = SimpleMaskMoney__default['default'].setMask(this._inputRef, this._config);
            this.changeDetectorRef.detectChanges();
        };
        NgMaskPercentDirective.prototype.onInput = function (event) {
            var _this = this;
            if (this._instanceSimpleMaskMoneyRef) {
                var value_1 = this.validRequired(this._instanceSimpleMaskMoneyRef.formatToNumber() / 100);
                this.onChange(value_1);
                this.changeDetectorRef.detectChanges();
                clearTimeout(this.eventTime);
                this.eventTime = setTimeout(function () {
                    _this.value.emit(value_1);
                });
            }
        };
        NgMaskPercentDirective.prototype.validRequired = function (value) {
            if (this._config.validator) {
                if (typeof value === 'string') {
                    return value.length === 0 ? null : value;
                }
                else if (typeof value === 'number') {
                    return value === 0 ? null : value;
                }
            }
            return value;
        };
        NgMaskPercentDirective.prototype.writeValue = function (value) {
            if (this._isPercent) {
                value = value.toString();
                value = value.replace(',', '.');
                value = calcJs__default['default'](value).value.toString();
                value = value.replace('.', this._config.decimalSeparator);
                this._inputRef.value = SimpleMaskMoney__default['default'].formatToCurrency(value, Object.assign(Object.assign({}, this._config), { allowNegative: false }));
                this.onInput();
            }
            else {
                this._inputRef.value = value.toString();
            }
        };
        return NgMaskPercentDirective;
    }());
    NgMaskPercentDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[ngMaskPercent]',
                    providers: [PROVIDER_VALUE_ACCESSOR$7],
                },] }
    ];
    NgMaskPercentDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 },
        { type: i0.ChangeDetectorRef }
    ]; };
    NgMaskPercentDirective.propDecorators = {
        ngMaskPercent: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        value: [{ type: i0.Output }],
        onTouched: [{ type: i0.HostListener, args: ['blur', ['$event.target'],] }],
        onFocus: [{ type: i0.HostListener, args: ['focus', ['$event.target'],] }]
    };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var TEL = {
        mask: [{ mask: '(00) 0000-0000' }, { mask: '(00) 0 0000-0000' }],
    };
    var CPF = {
        mask: '000.000.000-00',
    };
    var CNPJ = {
        mask: '00.000.000/0000-00',
    };
    var CPF_CNPJ = {
        mask: [CPF, CNPJ],
    };
    var RG = {
        mask: '00.000.000-0',
    };
    var ESTADUAL = {
        mask: '00.0.000.0000000-0',
    };
    var RG_ESTADUAL = {
        mask: [RG, ESTADUAL],
    };
    var ZIP_CODE = {
        mask: '00000-000',
    };
    var typesCustom = __spread(['ZIP_CODE', 'RG', 'RG_ESTADUAL', 'CPF_CNPJ', 'CNPJ', 'CPF', 'ESTADUAL']);

    var MASKS = /*#__PURE__*/Object.freeze({
        __proto__: null,
        TEL: TEL,
        CPF: CPF,
        CNPJ: CNPJ,
        CPF_CNPJ: CPF_CNPJ,
        RG: RG,
        ESTADUAL: ESTADUAL,
        RG_ESTADUAL: RG_ESTADUAL,
        ZIP_CODE: ZIP_CODE,
        typesCustom: typesCustom
    });

    var PROVIDER_VALUE_ACCESSOR$6 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgMaskDirective; }),
        multi: true,
    };
    var NgMaskDirective = /** @class */ (function () {
        function NgMaskDirective(elementRef, renderer2, changeDetectorRef) {
            var _this = this;
            this.elementRef = elementRef;
            this.renderer2 = renderer2;
            this.changeDetectorRef = changeDetectorRef;
            this._validator = true;
            this._isMask = false;
            this.type = '';
            this.value = new i0.EventEmitter();
            this.onTouched = function () { };
            this.eventTime = 0;
            this.onChange = function (_) { };
            this.registerOnTouched = function (fn) { return (_this.onTouched = fn); };
            this.setDisabledState = function (isDisabled) { };
            this.registerOnChange = function (fn) {
                _this.onChange = fn;
                if (_this._isMask) {
                    _this.onInput();
                }
            };
            this._inputRef = this.elementRef.nativeElement;
        }
        Object.defineProperty(NgMaskDirective.prototype, "ngMask", {
            set: function (value) {
                var _a, _b;
                if (!(typeof value === 'string')) {
                    this._mask = value;
                    if ((_a = value) === null || _a === void 0 ? void 0 : _a.validator) {
                        this._validator = (_b = value) === null || _b === void 0 ? void 0 : _b.validator;
                    }
                }
                else if (!!value) {
                    this._mask = {
                        mask: value.split('|').map(function (mask) { return ({
                            mask: mask,
                        }); }),
                    };
                }
                if (this._instanceIMaskMoneyRef !== undefined) {
                    this.createMask(this._mask);
                }
            },
            enumerable: false,
            configurable: true
        });
        NgMaskDirective.prototype.ngOnInit = function () {
            var _this = this;
            var keys = Object.keys(MASKS);
            var type = this.type.toUpperCase();
            if (keys.includes(type) && this._mask === undefined) {
                this._mask = MASKS[type];
            }
            if (this._mask !== undefined) {
                this._isMask = true;
                this.createMask();
                this.renderer2.listen(this._inputRef, 'input', function (event) { return _this.onInput(event); });
            }
        };
        NgMaskDirective.prototype.createMask = function (mask) {
            if (mask === void 0) { mask = this._mask; }
            if (typesCustom.includes(this.type)) {
                this.renderer2.setAttribute(this._inputRef, 'type', 'text');
            }
            if (this._instanceIMaskMoneyRef === undefined) {
                this._instanceIMaskMoneyRef = IMask__default['default'](this._inputRef, mask);
            }
            else {
                this._instanceIMaskMoneyRef.updateOptions(this._mask);
            }
            this.changeDetectorRef.detectChanges();
        };
        NgMaskDirective.prototype.onInput = function (event) {
            var _this = this;
            if (this._instanceIMaskMoneyRef) {
                var value_1 = this.validRequired(this._instanceIMaskMoneyRef.unmaskedValue);
                this.onChange(value_1);
                this.changeDetectorRef.detectChanges();
                clearTimeout(this.eventTime);
                this.eventTime = setTimeout(function () {
                    _this.value.emit(value_1);
                });
            }
        };
        NgMaskDirective.prototype.validRequired = function (value) {
            if (this._validator) {
                if (typeof value === 'string') {
                    return value.length === 0 ? null : value;
                }
                else if (typeof value === 'number') {
                    return value === 0 ? null : value;
                }
            }
            return value;
        };
        NgMaskDirective.prototype.writeValue = function (value) {
            if (this._isMask) {
                this._inputRef.value = IMask__default['default'].pipe(value.toString(), this._mask);
                this.onInput();
            }
            else {
                this._inputRef.value = value.toString();
            }
        };
        return NgMaskDirective;
    }());
    NgMaskDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[ngMask]',
                    providers: [PROVIDER_VALUE_ACCESSOR$6],
                },] }
    ];
    NgMaskDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 },
        { type: i0.ChangeDetectorRef }
    ]; };
    NgMaskDirective.propDecorators = {
        ngMask: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        value: [{ type: i0.Output }],
        onTouched: [{ type: i0.HostListener, args: ['blur', ['$event.target'],] }]
    };

    var NgMasksDirectivesModule = /** @class */ (function () {
        function NgMasksDirectivesModule() {
        }
        NgMasksDirectivesModule.forRoot = function () {
            return {
                ngModule: NgMasksDirectivesModule,
                providers: [],
            };
        };
        return NgMasksDirectivesModule;
    }());
    NgMasksDirectivesModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        NgMaskCurrencyDirective,
                        NgMaskDirective,
                        NgMaskPercentDirective,
                        NgMaskAmountDirective,
                    ],
                    exports: [
                        NgMaskCurrencyDirective,
                        NgMaskDirective,
                        NgMaskPercentDirective,
                        NgMaskAmountDirective,
                    ],
                },] }
    ];

    var NgMaskAmountService = /** @class */ (function () {
        function NgMaskAmountService(ngInputConfig) {
            var _a, _b;
            this._config = {
                allowNegative: true,
                fractionDigits: 3,
                decimalSeparator: ',',
                align: 'right',
                validator: true,
                focusSelectText: true,
            };
            Object.assign(this._config, (_b = (_a = ngInputConfig.config.global) === null || _a === void 0 ? void 0 : _a.input) === null || _b === void 0 ? void 0 : _b.amount);
        }
        NgMaskAmountService.prototype.createMask = function (inputRef, config, renderer2) {
            config = Object.assign({}, this._config, config);
            var input = function (event) {
                var input = event.target;
                input.value = NgMaskAmountService.prototype._formatAmount(input.value, config, event.data).valueFormat;
            };
            var focus = function (_c) {
                var target = _c.target;
                var length = target.value.length;
                target.setSelectionRange(0, length);
            };
            if (renderer2) {
                renderer2.listen(inputRef, 'input', input);
                if (config.validator) {
                    renderer2.listen(inputRef, 'focus', focus);
                }
            }
            else {
                inputRef.addEventListener('input', input);
                if (config.validator) {
                    inputRef.addEventListener('focus', focus);
                }
            }
            return {
                _instanceRef: null,
                _inputRef: inputRef,
                _config: config,
                _renderer2: renderer2,
                _validRequired: function (value) {
                    if (this._config.validator) {
                        if (typeof value === 'string') {
                            return value.length === 0 ? null : value;
                        }
                        else if (typeof value === 'number') {
                            return value === 0 ? null : value;
                        }
                    }
                    return value;
                },
                unmaskedValue: function () {
                    return this._validRequired(NgMaskAmountService.prototype._formatAmount(this._inputRef.value, this._config).value);
                },
                update: function (value) {
                    this._inputRef.value = NgMaskAmountService.prototype._formatAmount(value, this._config).valueFormat;
                },
            };
        };
        NgMaskAmountService.prototype.format = function (value, config) {
            config = Object.assign({}, this._config, config);
            return this._formatAmount(value, config).valueFormat;
        };
        NgMaskAmountService.prototype._formatAmount = function (value, config, data) {
            var negative = data === '-';
            value = value.toString();
            if (/^0/g.test(value)) {
                value = value.replace(/0+/, '');
            }
            if (new RegExp(config.decimalSeparator, 'g').test(value)) {
                value = value.replace(config.decimalSeparator, '.');
            }
            if (value.match('-')) {
                negative = true;
            }
            if (data === undefined) {
                value = Number.parseFloat(value)
                    .toFixed(config.fractionDigits)
                    .toString();
            }
            value = value.replace(/\D/g, '');
            value =
                Number.parseFloat(value) / Math.pow(10, config.fractionDigits);
            if (Number.isNaN(value)) {
                value = 0;
            }
            if (negative && config.allowNegative) {
                value = -value;
            }
            value = value.toFixed(config.fractionDigits);
            var valueFormat = value.toString();
            value = Number.parseFloat(value);
            valueFormat = valueFormat.replace('.', config.decimalSeparator);
            return { valueFormat: valueFormat, value: value };
        };
        return NgMaskAmountService;
    }());
    NgMaskAmountService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgMaskAmountService_Factory() { return new NgMaskAmountService(i0.ɵɵinject(NgConfigService)); }, token: NgMaskAmountService, providedIn: "root" });
    NgMaskAmountService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    NgMaskAmountService.ctorParameters = function () { return [
        { type: NgConfigService }
    ]; };

    var NgMaskCurrencyService = /** @class */ (function () {
        function NgMaskCurrencyService(ngInputConfig) {
            var _a, _b;
            this._locale = currencyToSymbolMap__default['default'].BRL;
            this._config = {
                allowNegative: true,
                negativeSignAfter: false,
                prefix: this._locale,
                suffix: '',
                fixed: true,
                fractionDigits: 2,
                decimalSeparator: ',',
                thousandsSeparator: '.',
                align: 'right',
                cursor: 'end',
                validator: true,
                focusSelectText: true,
            };
            Object.assign(this._config, (_b = (_a = ngInputConfig.config.global) === null || _a === void 0 ? void 0 : _a.input) === null || _b === void 0 ? void 0 : _b.currency);
        }
        NgMaskCurrencyService.prototype.createMask = function (inputRef, config, renderer2) {
            config = Object.assign({}, this._config, config);
            var instanceSimpleMaskMoneyRef = SimpleMaskMoney__default['default'].setMask(inputRef, config);
            var focus = function (_c) {
                var target = _c.target;
                var length = target.value.length;
                target.setSelectionRange(0, length);
            };
            if (config.validator) {
                if (renderer2) {
                    renderer2.listen(inputRef, 'focus', focus);
                }
                else {
                    inputRef.addEventListener('focus', focus);
                }
            }
            return {
                _instanceRef: instanceSimpleMaskMoneyRef,
                _inputRef: inputRef,
                _config: config,
                _renderer2: renderer2,
                _validRequired: function (value) {
                    if (this._config.validator) {
                        if (typeof value === 'string') {
                            return value.length === 0 ? null : value;
                        }
                        else if (typeof value === 'number') {
                            return value === 0 ? null : value;
                        }
                    }
                    return value;
                },
                unmaskedValue: function () {
                    return this._validRequired(this._instanceRef.formatToNumber());
                },
                update: function (value) {
                    this._inputRef.value = NgMaskCurrencyService.prototype.format(value, this._config);
                },
            };
        };
        NgMaskCurrencyService.prototype.format = function (value, config) {
            config = Object.assign({}, this._config, config);
            value = value.toString();
            value = value.replace(',', '.');
            value = calcJs__default['default'](value).value.toString();
            value = value.replace('.', config.decimalSeparator);
            return SimpleMaskMoney__default['default'].formatToCurrency(value, Object.assign(Object.assign({}, config), { allowNegative: false }));
        };
        return NgMaskCurrencyService;
    }());
    NgMaskCurrencyService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgMaskCurrencyService_Factory() { return new NgMaskCurrencyService(i0.ɵɵinject(NgConfigService)); }, token: NgMaskCurrencyService, providedIn: "root" });
    NgMaskCurrencyService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    NgMaskCurrencyService.ctorParameters = function () { return [
        { type: NgConfigService }
    ]; };

    var NgMaskPercentService = /** @class */ (function () {
        function NgMaskPercentService(ngInputConfig) {
            var _a, _b;
            this._config = {
                allowNegative: true,
                negativeSignAfter: false,
                prefix: '',
                suffix: '%',
                fixed: true,
                fractionDigits: 2,
                decimalSeparator: ',',
                thousandsSeparator: '.',
                align: 'right',
                cursor: 'end',
                validator: true,
                focusSelectText: true,
            };
            Object.assign(this._config, (_b = (_a = ngInputConfig.config.global) === null || _a === void 0 ? void 0 : _a.input) === null || _b === void 0 ? void 0 : _b.percent);
        }
        NgMaskPercentService.prototype.createMask = function (inputRef, config, renderer2) {
            config = Object.assign({}, this._config, config);
            var instanceSimpleMaskMoneyRef = SimpleMaskMoney__default['default'].setMask(inputRef, config);
            var focus = function (_c) {
                var target = _c.target;
                var length = target.value.length;
                target.setSelectionRange(0, length);
            };
            if (config.validator) {
                if (renderer2) {
                    renderer2.listen(inputRef, 'focus', focus);
                }
                else {
                    inputRef.addEventListener('focus', focus);
                }
            }
            return {
                _instanceRef: instanceSimpleMaskMoneyRef,
                _inputRef: inputRef,
                _config: config,
                _renderer2: renderer2,
                _validRequired: function (value) {
                    if (this._config.validator) {
                        if (typeof value === 'string') {
                            return value.length === 0 ? null : value;
                        }
                        else if (typeof value === 'number') {
                            return value === 0 ? null : value;
                        }
                    }
                    return value;
                },
                unmaskedValue: function () {
                    return this._validRequired(this._instanceRef.formatToNumber());
                },
                update: function (value) {
                    this._inputRef.value = NgMaskPercentService.prototype.format(value, this._config);
                },
            };
        };
        NgMaskPercentService.prototype.format = function (value, config) {
            config = Object.assign({}, this._config, config);
            value = value.toString();
            value = value.replace(',', '.');
            value = calcJs__default['default'](value).value.toString();
            value = value.replace('.', config.decimalSeparator);
            return SimpleMaskMoney__default['default'].formatToCurrency(value, Object.assign(Object.assign({}, config), { allowNegative: false }));
        };
        return NgMaskPercentService;
    }());
    NgMaskPercentService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgMaskPercentService_Factory() { return new NgMaskPercentService(i0.ɵɵinject(NgConfigService)); }, token: NgMaskPercentService, providedIn: "root" });
    NgMaskPercentService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    NgMaskPercentService.ctorParameters = function () { return [
        { type: NgConfigService }
    ]; };

    var NgMasksServicesModule = /** @class */ (function () {
        function NgMasksServicesModule() {
        }
        NgMasksServicesModule.forRoot = function () {
            return {
                ngModule: NgMasksServicesModule,
                providers: [
                    NgMaskAmountService,
                    NgMaskCurrencyService,
                    NgMaskPercentService,
                ],
            };
        };
        return NgMasksServicesModule;
    }());
    NgMasksServicesModule.decorators = [
        { type: i0.NgModule, args: [{
                    providers: [NgMaskAmountService, NgMaskCurrencyService, NgMaskPercentService],
                },] }
    ];

    var NgMaskService = /** @class */ (function () {
        function NgMaskService() {
        }
        NgMaskService.prototype.createMask = function (inputRef, mask, renderer2) {
            var validator = true;
            mask = this.formatTypeMask(mask, validator);
            var instanceMoneyRef = IMask__default['default'](inputRef, mask);
            var focus = function (_c) {
                var target = _c.target;
                var length = target.value.length;
                target.setSelectionRange(0, length);
            };
            if (validator) {
                if (renderer2) {
                    renderer2.listen(inputRef, 'focus', focus);
                }
                else {
                    inputRef.addEventListener('focus', focus);
                }
            }
            return {
                _instanceRef: instanceMoneyRef,
                _inputRef: inputRef,
                _validator: validator,
                _mask: mask,
                _renderer2: renderer2,
                _validRequired: function (value) {
                    if (this._validator) {
                        if (typeof value === 'string') {
                            return value.length === 0 ? null : value;
                        }
                        else if (typeof value === 'number') {
                            return value === 0 ? null : value;
                        }
                    }
                    return value;
                },
                unmaskedValue: function () {
                    return this._validRequired(this._instanceRef.unmaskedValue);
                },
                update: function (value) {
                    this._inputRef.value = NgMaskService.prototype.format(value, this._mask);
                },
            };
        };
        NgMaskService.prototype.format = function (value, mask) {
            mask = this.formatTypeMask(mask);
            return IMask__default['default'].pipe(value.toString(), mask);
        };
        NgMaskService.prototype.formatTypeMask = function (mask, validator) {
            if (validator === void 0) { validator = false; }
            var _a, _b;
            if (!(typeof mask === 'string')) {
                mask = mask;
                if ((_a = mask) === null || _a === void 0 ? void 0 : _a.validator) {
                    validator = (_b = mask) === null || _b === void 0 ? void 0 : _b.validator;
                }
            }
            else if (!!mask) {
                mask = {
                    mask: mask.split('|').map(function (mask) { return ({
                        mask: mask,
                    }); }),
                };
            }
            return mask;
        };
        return NgMaskService;
    }());
    NgMaskService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgMaskService_Factory() { return new NgMaskService(); }, token: NgMaskService, providedIn: "root" });
    NgMaskService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];

    var NgMaskPipe = /** @class */ (function () {
        function NgMaskPipe(ngMaskService) {
            this.ngMaskService = ngMaskService;
        }
        NgMaskPipe.prototype.transform = function (value, mask) {
            if (typeof mask === 'string') {
                mask = mask.toUpperCase();
                if (typesCustom.includes(mask)) {
                    mask = MASKS[mask];
                }
            }
            return this.ngMaskService.format(value, mask);
        };
        return NgMaskPipe;
    }());
    NgMaskPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'ngMask',
                },] }
    ];
    NgMaskPipe.ctorParameters = function () { return [
        { type: NgMaskService }
    ]; };

    var NgMaskAmountPipe = /** @class */ (function () {
        function NgMaskAmountPipe(ngMaskAmountService) {
            this.ngMaskAmountService = ngMaskAmountService;
        }
        NgMaskAmountPipe.prototype.transform = function (value, config) {
            return this.ngMaskAmountService.format(value, config);
        };
        return NgMaskAmountPipe;
    }());
    NgMaskAmountPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'ngMaskAmount',
                },] }
    ];
    NgMaskAmountPipe.ctorParameters = function () { return [
        { type: NgMaskAmountService }
    ]; };

    var NgMaskCurrencyPipe = /** @class */ (function () {
        function NgMaskCurrencyPipe(ngMaskCurrencyService) {
            this.ngMaskCurrencyService = ngMaskCurrencyService;
        }
        NgMaskCurrencyPipe.prototype.transform = function (value, config) {
            return this.ngMaskCurrencyService.format(value, config);
        };
        return NgMaskCurrencyPipe;
    }());
    NgMaskCurrencyPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'ngMaskCurrency',
                },] }
    ];
    NgMaskCurrencyPipe.ctorParameters = function () { return [
        { type: NgMaskCurrencyService }
    ]; };

    var NgMaskPercentPipe = /** @class */ (function () {
        function NgMaskPercentPipe(ngMaskPercentService) {
            this.ngMaskPercentService = ngMaskPercentService;
        }
        NgMaskPercentPipe.prototype.transform = function (value, config) {
            return this.ngMaskPercentService.format(value, config);
        };
        return NgMaskPercentPipe;
    }());
    NgMaskPercentPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'ngMaskPercent',
                },] }
    ];
    NgMaskPercentPipe.ctorParameters = function () { return [
        { type: NgMaskPercentService }
    ]; };

    var NgMaskPipeModule = /** @class */ (function () {
        function NgMaskPipeModule() {
        }
        return NgMaskPipeModule;
    }());
    NgMaskPipeModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [NgMasksServicesModule],
                    declarations: [
                        NgMaskPipe,
                        NgMaskAmountPipe,
                        NgMaskPercentPipe,
                        NgMaskCurrencyPipe,
                    ],
                    exports: [
                        NgMaskPipe,
                        NgMaskAmountPipe,
                        NgMaskPercentPipe,
                        NgMaskCurrencyPipe,
                    ],
                },] }
    ];

    var getProp = function (object, prop) {
        if (typeof prop === 'string') {
            prop = prop.split('.');
        }
        prop = __spread(prop);
        var lastLabel = __spread(prop);
        var rest = prop.splice(1, prop.length - 1);
        return lastLabel.length === 1
            ? object[lastLabel[0]]
            : getProp(object[lastLabel[0]], rest);
    };

    var PROVIDER_VALUE_ACCESSOR$5 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgAutocompleteComponent; }),
        multi: true,
    };
    var NgAutocompleteComponent = /** @class */ (function () {
        function NgAutocompleteComponent(_controlContainer, renderer2, ngMaskCurrencyService, ngMaskPercentService, ngMaskAmountService, ngMaskService, ngInputConfig, changeDetectorRef) {
            var _this = this;
            this._controlContainer = _controlContainer;
            this.renderer2 = renderer2;
            this.ngMaskCurrencyService = ngMaskCurrencyService;
            this.ngMaskPercentService = ngMaskPercentService;
            this.ngMaskAmountService = ngMaskAmountService;
            this.ngMaskService = ngMaskService;
            this.ngInputConfig = ngInputConfig;
            this.changeDetectorRef = changeDetectorRef;
            this.loading = false;
            this.debounceTimeMenuClose = 250;
            this.debounceTimeEventInput = 350;
            this.propLabel = '';
            this.propReturn = null;
            this.showContentIsEmpty = true;
            this._dropdownIsOpen = false;
            this._indexSelect = null;
            this._indexFocus = null;
            this._options = [];
            this.label = '';
            this.type = 'text';
            this.readonly = false;
            this.disabled = false;
            this.size = 'md';
            this.debounceTimeBlur = 0;
            this.blur = new i0.EventEmitter();
            this.focus = new i0.EventEmitter();
            this.debounceTimeInput = 0;
            this.inputDebounce = new i0.EventEmitter();
            this.handleChange = function (_) { };
            this.handleTouched = function () { };
            this.registerOnTouched = function (fn) { return (_this.handleTouched = fn); };
            this.setDisabledState = function (isDisabled) { return (_this.disabled = isDisabled); };
            this.registerOnChange = function (fn) { return (_this.handleChange = fn); };
            this.writeValue = function (value) {
                if (_this.inputRef) {
                    if (_this._maskRef) {
                        _this._maskRef.update(value);
                    }
                    else {
                        _this.inputRef.nativeElement.value = value.toString();
                    }
                    _this.handleSaveValue(value);
                }
                else {
                    setTimeout(function () {
                        _this.writeValue(value);
                    }, 10);
                }
            };
        }
        Object.defineProperty(NgAutocompleteComponent.prototype, "options", {
            set: function (value) {
                var _this = this;
                this._options = value.reduce(function (prev, current) {
                    var result = { _label: getProp(current, _this.propLabel) };
                    if (_this.propReturn) {
                        result._value = getProp(current, _this.propReturn);
                    }
                    else {
                        result._value = current;
                    }
                    return prev.concat(result);
                }, []);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgAutocompleteComponent.prototype, "placeholder", {
            set: function (text) {
                var _a;
                this._placeholder = text;
                if (!!text && ((_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.nativeElement)) {
                    this.renderer2.setAttribute(this.inputRef.nativeElement, 'placeholder', text);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgAutocompleteComponent.prototype, "errors", {
            set: function (errors) {
                this._errors = errors;
                this._errorsKeys = Object.keys(errors);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgAutocompleteComponent.prototype, "control", {
            get: function () {
                var _a, _b;
                return (this.formControl || ((_b = (_a = this._controlContainer) === null || _a === void 0 ? void 0 : _a.control) === null || _b === void 0 ? void 0 : _b.get(this.formControlName)));
            },
            enumerable: false,
            configurable: true
        });
        NgAutocompleteComponent.prototype.ngOnInit = function () {
            var _a, _b;
            if (this.id === undefined) {
                this.id = this.formControlName;
            }
            var value = this.control.value;
            this.control.reset();
            this.required = !!this.control.getError('required');
            this.control.setValue(value);
            var typeConfig = (_a = this.ngInputConfig.typesAutocompleta) === null || _a === void 0 ? void 0 : _a[this.type.toLowerCase()];
            this.icon = Object.assign({}, (_b = this.ngInputConfig.autocomplete) === null || _b === void 0 ? void 0 : _b.icon, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.icon, this.icon);
        };
        NgAutocompleteComponent.prototype.ngAfterViewInit = function () {
            var _a;
            if (!!this._placeholder) {
                this.placeholder = this._placeholder;
            }
            var typeConfig = (_a = this.ngInputConfig.typesInput) === null || _a === void 0 ? void 0 : _a[this.type.toLowerCase()];
            var keys = Object.keys(MASKS);
            var type = this.type.toUpperCase();
            if (keys.includes(type) && this.mask === undefined) {
                this.mask = MASKS[type];
            }
            if (typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.mask) {
                this.mask = Object.assign({}, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.mask, this.mask);
            }
            if (this.mask !== undefined) {
                this._maskRef = this.ngMaskService.createMask(this.inputRef.nativeElement, this.mask, this.renderer2);
                if (typesCustom.includes(type)) {
                    this.type = 'text';
                }
            }
            this.inputRef.nativeElement.blur();
            this.control.markAsUntouched();
            this.changeDetectorRef.detectChanges();
        };
        NgAutocompleteComponent.prototype.handleClickIcon = function (event, input, icon, position) {
            event.stopPropagation();
            if (icon === null || icon === void 0 ? void 0 : icon.click) {
                icon.click(event, input, icon, position);
            }
            else {
                input.focus();
            }
        };
        NgAutocompleteComponent.prototype.handleBlur = function (event, index) {
            var _this = this;
            this.handleTouched();
            this.blur.emit(event);
            clearTimeout(this.debounceTimeBlur);
            this.debounceTimeBlur = setTimeout(function () {
                _this.handleCloseMenu();
            }, this.debounceTimeMenuClose);
        };
        NgAutocompleteComponent.prototype.handleFocus = function (event) {
            this.focus.emit(event);
            this.handleOpenMenu();
            clearTimeout(this.debounceTimeBlur);
        };
        NgAutocompleteComponent.prototype.handleInput = function (event) {
            var _a;
            var value = event.target.value;
            if (!!event.key.match('Arrow')) {
                event.preventDefault();
                if (!this._dropdownIsOpen) {
                    this.handleOpenMenu();
                }
                var dropdown = (_a = this.inputRef.nativeElement.parentElement) === null || _a === void 0 ? void 0 : _a.querySelector('.dropdown-menu');
                var items = dropdown === null || dropdown === void 0 ? void 0 : dropdown.querySelectorAll('.ng-dropdown-item');
                if (event.key === 'ArrowDown') {
                    if (typeof this._indexFocus === 'number') {
                        this._indexFocus += 1;
                    }
                    else {
                        this._indexFocus = 0;
                    }
                    var element = items === null || items === void 0 ? void 0 : items.item(this._indexFocus);
                    if (!element) {
                        this._indexFocus = null;
                        this.inputRef.nativeElement.focus();
                    }
                    else {
                        element.focus();
                    }
                }
                else if (event.key === 'ArrowUp') {
                    if (typeof this._indexFocus === 'number') {
                        this._indexFocus -= 1;
                    }
                    else {
                        this._indexFocus = this._options.length - 1;
                    }
                    var element = items === null || items === void 0 ? void 0 : items.item(this._indexFocus);
                    if (!element) {
                        this._indexFocus = null;
                        this.inputRef.nativeElement.focus();
                    }
                    else {
                        element.focus();
                    }
                }
            }
            else {
                if (event.key !== 'Enter') {
                    this.handleSaveValue(value);
                    this.handleInputDebounce(value);
                }
            }
        };
        NgAutocompleteComponent.prototype.handleSaveValue = function (value) {
            if (this._maskRef) {
                this.handleChange(this._maskRef.unmaskedValue());
            }
            else {
                this.handleChange(value);
            }
        };
        NgAutocompleteComponent.prototype.handleInputDebounce = function (value) {
            var _this = this;
            clearTimeout(this.debounceTimeInput);
            this.debounceTimeInput = setTimeout(function () {
                _this.handleSearch(value);
                console.log(value);
                _this.inputDebounce.emit(value);
            }, this.debounceTimeEventInput);
        };
        NgAutocompleteComponent.prototype.handleOpenMenu = function (event) {
            this._dropdownIsOpen = true;
        };
        NgAutocompleteComponent.prototype.handleCloseMenu = function (event) {
            this._dropdownIsOpen = false;
        };
        NgAutocompleteComponent.prototype.handleSearch = function (value) {
            return __awaiter(this, void 0, void 0, function () {
                var _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            this.loading = true;
                            _c = this;
                            return [4 /*yield*/, this.funcSearch(value)];
                        case 1:
                            _c.options = _d.sent();
                            this.loading = false;
                            return [2 /*return*/];
                    }
                });
            });
        };
        NgAutocompleteComponent.prototype.handleSelect = function (index) {
            this.inputRef.nativeElement.focus();
            this._indexSelect = index;
            this.handleCloseMenu();
            this.handleSaveValue(this._options[index]._value);
            this.inputRef.nativeElement.value = this._options[index]._label;
        };
        return NgAutocompleteComponent;
    }());
    NgAutocompleteComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-autocomplete',
                    template: "<label class=\"form-label\" *ngIf=\"label\" [for]=\"id\">{{ label }}</label>\n\n<div class=\"input-group\">\n  <button\n    type=\"button\"\n    [disabled]=\"icon?.left?.disabled\"\n    *ngIf=\"icon?.left && !icon?.left?.hidden && !loading\"\n    class=\"ng-icon ng-icon__left input-group-text\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    (click)=\"handleClickIcon($event, inputRef, icon.left, 'left')\"\n    [tabIndex]=\"icon?.left?.disabled || !icon?.left?.click ? -1 : 1\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n    [class.shadow-focus]=\"!icon?.left?.disabled && icon?.left?.click\"\n    [class.ng-icon__clickable]=\"!icon?.left?.disabled && icon?.left?.click\"\n  >\n    <i [class]=\"icon?.left?.class\" [ngStyle]=\"{ color: icon?.left?.color }\"></i>\n  </button>\n\n  <!-- TEMPO INDETERMINADO // CONVERTER \u00CDCONES PARA UM COMPONENTE -->\n  <button\n    type=\"button\"\n    [disabled]=\"icon?.loading?.disabled\"\n    class=\"ng-icon ng-icon__left input-group-text\"\n    [class.ng-icon__clickable]=\"\n      !icon?.loading?.disabled && icon?.loading?.click\n    \"\n    *ngIf=\"icon?.loading && !icon?.loading?.hidden && loading\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    (click)=\"handleClickIcon($event, inputRef, icon.loading, 'left')\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n    [tabIndex]=\"icon?.loading?.disabled || !icon?.loading?.click ? -1 : 1\"\n    [class.shadow-focus]=\"!icon?.loading?.disabled && icon?.loading?.click\"\n  >\n    <i\n      [class]=\"icon?.loading?.class\"\n      [ngStyle]=\"{ color: icon?.loading?.color }\"\n    ></i>\n  </button>\n\n  <input\n    [id]=\"id\"\n    #inputRef\n    [type]=\"type\"\n    autocomplete=\"off\"\n    [readonly]=\"readonly\"\n    [formControl]=\"control\"\n    [class.disabled]=\"disabled\"\n    [class.readonly]=\"readonly\"\n    (blur)=\"handleBlur($event)\"\n    (focus)=\"handleFocus($event)\"\n    (click)=\"handleOpenMenu($event)\"\n    class=\"form-control shadow-focus\"\n    [tabIndex]=\"control.disabled ? -1 : 1\"\n    [class.form-control-sm]=\"size === 'sm'\"\n    [class.form-control-lg]=\"size === 'lg'\"\n    [class.ng-icon__left]=\"icon?.left && !icon?.left?.hidden\"\n    [class.ng-icon__right]=\"icon?.right && !icon?.right?.hidden\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n  />\n\n  <button\n    type=\"button\"\n    [disabled]=\"icon?.right?.disabled\"\n    [tabIndex]=\"icon?.right?.disabled ? -1 : 1\"\n    *ngIf=\"icon?.right && !icon?.right?.hidden\"\n    class=\"ng-icon ng-icon__right input-group-text\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    (click)=\"handleClickIcon($event, inputRef, icon.right, 'right')\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n    [class.shadow-focus]=\"!icon?.right?.disabled && icon?.right?.click\"\n    [class.ng-icon__clickable]=\"!icon?.right?.disabled && icon?.right?.click\"\n  >\n    <i\n      [ngStyle]=\"{ color: icon?.right?.color }\"\n      [class]=\"icon?.right?.class\"\n    ></i>\n  </button>\n\n  <ul\n    class=\"dropdown-menu ng-dropdown show\"\n    *ngIf=\"_dropdownIsOpen && !loading\"\n  >\n    <ng-content *ngIf=\"_options.length === 0\"></ng-content>\n    <button\n      tabIndex=\"1\"\n      (click)=\"handleSelect(index)\"\n      (focus)=\"handleFocus($event)\"\n      (blur)=\"handleBlur($event, index)\"\n      (keyup.enter)=\"handleSelect(index)\"\n      class=\"ng-dropdown-item dropdown-item\"\n      [class.active]=\"_indexSelect === index\"\n      *ngFor=\"let option of _options; let index = index\"\n    >\n      {{ option?._label }}\n    </button>\n  </ul>\n</div>\n\n<div class=\"ng-helper\">\n  <span\n    class=\"ng-helper__text text-muted\"\n    *ngIf=\"help && !(control.touched && control.invalid)\"\n  >\n    {{ help }}\n  </span>\n\n  <ng-container *ngFor=\"let errorKey of _errorsKeys\">\n    <span\n      class=\"ng-helper__text ng-helper__error\"\n      *ngIf=\"control.touched && control.getError(errorKey)\"\n    >\n      {{ _errors[errorKey] }}\n    </span>\n  </ng-container>\n</div>\n",
                    providers: [PROVIDER_VALUE_ACCESSOR$5]
                },] }
    ];
    NgAutocompleteComponent.ctorParameters = function () { return [
        { type: forms.ControlContainer },
        { type: i0.Renderer2 },
        { type: NgMaskCurrencyService },
        { type: NgMaskPercentService },
        { type: NgMaskAmountService },
        { type: NgMaskService },
        { type: NgConfigService },
        { type: i0.ChangeDetectorRef, decorators: [{ type: i0.SkipSelf }] }
    ]; };
    NgAutocompleteComponent.propDecorators = {
        formControlDirective: [{ type: i0.ViewChild, args: [forms.FormControlDirective, { static: true },] }],
        inputRef: [{ type: i0.ViewChild, args: ['inputRef',] }],
        formControl: [{ type: i0.Input }],
        formControlName: [{ type: i0.Input }],
        loading: [{ type: i0.Input }],
        funcSearch: [{ type: i0.Input }],
        debounceTimeMenuClose: [{ type: i0.Input }],
        debounceTimeEventInput: [{ type: i0.Input }],
        propLabel: [{ type: i0.Input }],
        propReturn: [{ type: i0.Input }],
        showContentIsEmpty: [{ type: i0.Input }],
        options: [{ type: i0.Input }],
        id: [{ type: i0.Input }],
        label: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        readonly: [{ type: i0.Input }],
        placeholder: [{ type: i0.Input }],
        help: [{ type: i0.Input }],
        required: [{ type: i0.Input }],
        icon: [{ type: i0.Input }],
        mask: [{ type: i0.Input }],
        size: [{ type: i0.Input }],
        errors: [{ type: i0.Input }],
        blur: [{ type: i0.Output }],
        focus: [{ type: i0.Output }],
        handleInput: [{ type: i0.HostListener, args: ['keyup', ['$event'],] }],
        inputDebounce: [{ type: i0.Output }]
    };

    var NgAutocompleteModule = /** @class */ (function () {
        function NgAutocompleteModule() {
        }
        return NgAutocompleteModule;
    }());
    NgAutocompleteModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule, forms.ReactiveFormsModule],
                    declarations: [NgAutocompleteComponent],
                    providers: [NgMaskService],
                    exports: [NgAutocompleteComponent],
                },] }
    ];

    var NgFormatDateByTypeService = /** @class */ (function () {
        function NgFormatDateByTypeService() {
            this.typeDate = ['date', 'datetime-local', 'month', 'time'];
        }
        NgFormatDateByTypeService.prototype.format = function (value, typeDate) {
            var formulation = {
                'datetime-local': dayjs__namespace(value).format('YYYY-MM-DDTHH:mm:ss'),
                date: dayjs__namespace(value).format('YYYY-MM-DD'),
                month: dayjs__namespace(value).format('YYYY-MM'),
                time: dayjs__namespace(value).format('HH:mm'),
            };
            return formulation[typeDate];
        };
        return NgFormatDateByTypeService;
    }());
    NgFormatDateByTypeService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgFormatDateByTypeService_Factory() { return new NgFormatDateByTypeService(); }, token: NgFormatDateByTypeService, providedIn: "root" });
    NgFormatDateByTypeService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    NgFormatDateByTypeService.ctorParameters = function () { return []; };

    var PROVIDER_VALUE_ACCESSOR$4 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgInputComponent; }),
        multi: true,
    };
    var NgInputComponent = /** @class */ (function () {
        function NgInputComponent(_controlContainer, renderer2, ngMaskCurrencyService, ngMaskPercentService, ngMaskAmountService, ngFormatDateByTypeService, ngMaskService, ngInputConfig, changeDetectorRef) {
            var _this = this;
            this._controlContainer = _controlContainer;
            this.renderer2 = renderer2;
            this.ngMaskCurrencyService = ngMaskCurrencyService;
            this.ngMaskPercentService = ngMaskPercentService;
            this.ngMaskAmountService = ngMaskAmountService;
            this.ngFormatDateByTypeService = ngFormatDateByTypeService;
            this.ngMaskService = ngMaskService;
            this.ngInputConfig = ngInputConfig;
            this.changeDetectorRef = changeDetectorRef;
            this.label = '';
            this.type = 'text';
            this.readonly = false;
            this.disabled = false;
            this.size = 'md';
            this.date = new Date();
            this.fill = false;
            this.blur = new i0.EventEmitter();
            this.focus = new i0.EventEmitter();
            this.handleChange = function (_) { };
            this.handleTouched = function () { };
            this.registerOnTouched = function (fn) { return (_this.handleTouched = fn); };
            this.setDisabledState = function (isDisabled) { return (_this.disabled = isDisabled); };
            this.registerOnChange = function (fn) { return (_this.handleChange = fn); };
            this.writeValue = function (value) {
                if (_this.inputRef) {
                    if (_this._maskRef) {
                        _this._maskRef.update(value);
                    }
                    else {
                        if (_this.ngFormatDateByTypeService.typeDate.includes(_this.type)) {
                            if (!!value) {
                                _this.inputRef.nativeElement.value = _this.formatDate(value);
                            }
                        }
                        else {
                            _this.inputRef.nativeElement.value = value.toString();
                        }
                    }
                    _this.handleInput(value);
                }
                else {
                    setTimeout(function () {
                        _this.writeValue(value);
                    }, 10);
                }
            };
        }
        Object.defineProperty(NgInputComponent.prototype, "placeholder", {
            set: function (text) {
                var _a;
                this._placeholder = text;
                if (!!text && ((_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.nativeElement)) {
                    this.renderer2.setAttribute(this.inputRef.nativeElement, 'placeholder', text);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgInputComponent.prototype, "errors", {
            set: function (errors) {
                this._errors = errors;
                this._errorsKeys = Object.keys(errors);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgInputComponent.prototype, "control", {
            get: function () {
                var _a, _b;
                return (this.formControl || ((_b = (_a = this._controlContainer) === null || _a === void 0 ? void 0 : _a.control) === null || _b === void 0 ? void 0 : _b.get(this.formControlName)));
            },
            enumerable: false,
            configurable: true
        });
        NgInputComponent.prototype.ngOnInit = function () {
            var _a, _b;
            if (this.id === undefined) {
                this.id = this.formControlName;
            }
            var value = this.control.value;
            this.control.reset();
            this.required = !!this.control.getError('required');
            this.control.setValue(value);
            var typeConfig = (_a = this.ngInputConfig.typesInput) === null || _a === void 0 ? void 0 : _a[this.type.toLowerCase()];
            this.icon = Object.assign({}, (_b = this.ngInputConfig.input) === null || _b === void 0 ? void 0 : _b.icon, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.icon, this.icon);
        };
        NgInputComponent.prototype.ngAfterViewInit = function () {
            var _a;
            if (!!this._placeholder) {
                this.placeholder = this._placeholder;
            }
            var typeConfig = (_a = this.ngInputConfig.typesInput) === null || _a === void 0 ? void 0 : _a[this.type.toLowerCase()];
            if (this.type === 'currency') {
                this.currency = Object.assign({}, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.currency, this.currency);
                this._maskRef = this.ngMaskCurrencyService.createMask(this.inputRef.nativeElement, this.currency, this.renderer2);
                this.type = 'text';
            }
            else if (this.type === 'percent') {
                this.percent = Object.assign({}, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.percent, this.percent);
                this._maskRef = this.ngMaskPercentService.createMask(this.inputRef.nativeElement, this.percent, this.renderer2);
                this.type = 'text';
            }
            else if (this.type === 'amount') {
                this.amount = Object.assign({}, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.amount, this.amount);
                this._maskRef = this.ngMaskAmountService.createMask(this.inputRef.nativeElement, this.amount, this.renderer2);
                this.type = 'text';
            }
            else {
                var type = this.type.toUpperCase();
                if (typesCustom.includes(type) && this.mask === undefined) {
                    this.mask = MASKS[type];
                }
                if (typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.mask) {
                    this.mask = Object.assign({}, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.mask, this.mask);
                }
                if (this.mask !== undefined) {
                    this._maskRef = this.ngMaskService.createMask(this.inputRef.nativeElement, this.mask, this.renderer2);
                    if (typesCustom.includes(type)) {
                        this.type = 'text';
                    }
                }
            }
            if (this.fill &&
                this.ngFormatDateByTypeService.typeDate.includes(this.type)) {
                this.inputRef.nativeElement.value = this.formatDate(this.date);
            }
            this.inputRef.nativeElement.blur();
            this.control.markAsUntouched();
            this.changeDetectorRef.detectChanges();
        };
        NgInputComponent.prototype.formatDate = function (value) {
            return this.ngFormatDateByTypeService.format(value.toString(), this.type);
        };
        NgInputComponent.prototype.handleClickIcon = function (event, input, icon, position) {
            event.stopPropagation();
            if (icon === null || icon === void 0 ? void 0 : icon.click) {
                icon.click(event, input, icon, position);
            }
            else {
                input.focus();
            }
        };
        NgInputComponent.prototype.handleBlur = function (event) {
            this.handleTouched();
            this.blur.emit(event);
        };
        NgInputComponent.prototype.handleFocus = function (event) {
            this.focus.emit(event);
        };
        NgInputComponent.prototype.handleInput = function (value) {
            if (this._maskRef) {
                this.handleChange(this._maskRef.unmaskedValue());
            }
            else {
                this.handleChange(value);
            }
        };
        return NgInputComponent;
    }());
    NgInputComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-input',
                    template: "<label class=\"form-label\" *ngIf=\"label\" [for]=\"id\">{{ label }}</label>\n\n<div class=\"input-group\">\n  <button\n    type=\"button\"\n    [disabled]=\"icon?.left?.disabled\"\n    *ngIf=\"icon?.left && !icon?.left?.hidden\"\n    class=\"ng-icon ng-icon__left input-group-text\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    (click)=\"handleClickIcon($event, inputRef, icon.left, 'left')\"\n    [tabIndex]=\"icon?.left?.disabled || !icon?.left?.click ? -1 : 1\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n    [class.shadow-focus]=\"!icon?.left?.disabled && icon?.left?.click\"\n    [class.ng-icon__clickable]=\"!icon?.left?.disabled && icon?.left?.click\"\n  >\n    <i [class]=\"icon?.left?.class\" [ngStyle]=\"{ color: icon?.left?.color }\"></i>\n  </button>\n\n  <input\n    [id]=\"id\"\n    #inputRef\n    [type]=\"type\"\n    [readonly]=\"readonly\"\n    [formControl]=\"control\"\n    [attr.maxlength]=\"length\"\n    [class.disabled]=\"disabled\"\n    [class.readonly]=\"readonly\"\n    (blur)=\"handleBlur($event)\"\n    (focus)=\"handleFocus($event)\"\n    class=\"form-control shadow-focus\"\n    [tabIndex]=\"control.disabled ? -1 : 1\"\n    [class.form-control-sm]=\"size === 'sm'\"\n    [class.form-control-lg]=\"size === 'lg'\"\n    [class.ng-icon__left]=\"icon?.left && !icon?.left?.hidden\"\n    [class.ng-icon__right]=\"icon?.right && !icon?.right?.hidden\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n  />\n\n  <button\n    type=\"button\"\n    [disabled]=\"icon?.right?.disabled\"\n    [tabIndex]=\"icon?.right?.disabled ? -1 : 1\"\n    *ngIf=\"icon?.right && !icon?.right?.hidden\"\n    class=\"ng-icon ng-icon__right input-group-text\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    (click)=\"handleClickIcon($event, inputRef, icon.right, 'right')\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n    [class.shadow-focus]=\"!icon?.right?.disabled && icon?.right?.click\"\n    [class.ng-icon__clickable]=\"!icon?.right?.disabled && icon?.right?.click\"\n  >\n    <i\n      [ngStyle]=\"{ color: icon?.right?.color }\"\n      [class]=\"icon?.right?.class\"\n    ></i>\n  </button>\n</div>\n\n<div class=\"ng-helper\">\n  <span\n    class=\"ng-helper__text text-muted\"\n    *ngIf=\"help && !(control.touched && control.invalid)\"\n  >\n    {{ help }}\n  </span>\n\n  <ng-container *ngFor=\"let errorKey of _errorsKeys\">\n    <span\n      class=\"ng-helper__text ng-helper__error\"\n      *ngIf=\"control.touched && control.getError(errorKey)\"\n    >\n      {{ _errors[errorKey] }}\n    </span>\n  </ng-container>\n\n  <span class=\"ng-helper__counter text-muted\" *ngIf=\"length\">\n    {{ inputRef?.value?.length }}/{{ length }}\n  </span>\n</div>\n",
                    providers: [PROVIDER_VALUE_ACCESSOR$4]
                },] }
    ];
    NgInputComponent.ctorParameters = function () { return [
        { type: forms.ControlContainer },
        { type: i0.Renderer2 },
        { type: NgMaskCurrencyService },
        { type: NgMaskPercentService },
        { type: NgMaskAmountService },
        { type: NgFormatDateByTypeService },
        { type: NgMaskService },
        { type: NgConfigService },
        { type: i0.ChangeDetectorRef, decorators: [{ type: i0.SkipSelf }] }
    ]; };
    NgInputComponent.propDecorators = {
        formControlDirective: [{ type: i0.ViewChild, args: [forms.FormControlDirective, { static: true },] }],
        inputRef: [{ type: i0.ViewChild, args: ['inputRef',] }],
        formControl: [{ type: i0.Input }],
        formControlName: [{ type: i0.Input }],
        id: [{ type: i0.Input }],
        label: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        readonly: [{ type: i0.Input }],
        placeholder: [{ type: i0.Input }],
        help: [{ type: i0.Input }],
        required: [{ type: i0.Input }],
        amount: [{ type: i0.Input }],
        percent: [{ type: i0.Input }],
        currency: [{ type: i0.Input }],
        length: [{ type: i0.Input }],
        icon: [{ type: i0.Input }],
        mask: [{ type: i0.Input }],
        size: [{ type: i0.Input }],
        date: [{ type: i0.Input }],
        fill: [{ type: i0.Input }],
        errors: [{ type: i0.Input }],
        blur: [{ type: i0.Output }],
        focus: [{ type: i0.Output }],
        handleInput: [{ type: i0.HostListener, args: ['input', ['$event.target.value'],] }]
    };

    var NgUtilsServiceModule = /** @class */ (function () {
        function NgUtilsServiceModule() {
        }
        NgUtilsServiceModule.forRoot = function () {
            return {
                ngModule: NgUtilsServiceModule,
                providers: [NgFormatDateByTypeService],
            };
        };
        return NgUtilsServiceModule;
    }());
    NgUtilsServiceModule.decorators = [
        { type: i0.NgModule, args: [{
                    providers: [NgFormatDateByTypeService],
                },] }
    ];

    var NgInputModule = /** @class */ (function () {
        function NgInputModule() {
        }
        return NgInputModule;
    }());
    NgInputModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        NgConfigModule,
                        NgMasksServicesModule,
                        forms.ReactiveFormsModule,
                        NgUtilsServiceModule,
                    ],
                    declarations: [NgInputComponent],
                    exports: [NgInputComponent],
                },] }
    ];

    var PROVIDER_VALUE_ACCESSOR$3 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgSelectComponent; }),
        multi: true,
    };
    var NgSelectComponent = /** @class */ (function (_super) {
        __extends(NgSelectComponent, _super);
        function NgSelectComponent(_controlContainer, renderer2, ngInputConfig, elementRef, changeDetectorRef) {
            var _this = _super.call(this, renderer2, elementRef) || this;
            _this._controlContainer = _controlContainer;
            _this.renderer2 = renderer2;
            _this.ngInputConfig = ngInputConfig;
            _this.changeDetectorRef = changeDetectorRef;
            _this.label = '';
            _this.type = 'select';
            _this.readonly = false;
            _this.disabled = false;
            _this.propCompare = '';
            _this.size = 'md';
            _this.position = 'start';
            _this._options = [];
            _this.focus = new i0.EventEmitter();
            _this.handleChange = function (_) { };
            _this.setDisabledState = function (isDisabled) { return (_this.disabled = isDisabled); };
            _this.registerOnChange = function (fn) { return (_this.handleChange = fn); };
            _this.writeValue = function (value) { };
            return _this;
        }
        Object.defineProperty(NgSelectComponent.prototype, "options", {
            set: function (options) {
                var _this = this;
                this._options = options.map(function (option) {
                    var label = '';
                    var value = '';
                    if (!(option === null || option === void 0 ? void 0 : option.label)) {
                        label = getProp(option, _this.propLabel);
                    }
                    if (!(typeof option.value === 'string')) {
                        if (_this.propValue) {
                            value = getProp(option, _this.propValue);
                        }
                        else {
                            value = option.value || option;
                        }
                    }
                    option = {
                        label: label,
                        value: value,
                    };
                    return option;
                });
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgSelectComponent.prototype, "errors", {
            set: function (errors) {
                this._errors = errors;
                this._errorsKeys = Object.keys(errors);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgSelectComponent.prototype, "control", {
            get: function () {
                var _a, _b;
                return (this.formControl || ((_b = (_a = this._controlContainer) === null || _a === void 0 ? void 0 : _a.control) === null || _b === void 0 ? void 0 : _b.get(this.formControlName)));
            },
            enumerable: false,
            configurable: true
        });
        NgSelectComponent.prototype.ngOnInit = function () {
            var _a, _b;
            if (this.id === undefined) {
                this.id = this.formControlName;
            }
            var value = this.control.value;
            this.control.reset();
            this.required = !!this.control.getError('required');
            this.control.setValue(value);
            var typeConfig = (_a = this.ngInputConfig.typesSelect) === null || _a === void 0 ? void 0 : _a[this.type];
            this.icon = Object.assign({}, (_b = this.ngInputConfig.select) === null || _b === void 0 ? void 0 : _b.icon, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.icon, this.icon);
        };
        NgSelectComponent.prototype.handleCompareWith = function (itemOne, itemTwo) {
            return itemOne && itemTwo
                ? getProp(itemOne, this.propCompare) ===
                    getProp(itemTwo, this.propCompare)
                : itemOne === itemTwo;
        };
        NgSelectComponent.prototype.handleClickIcon = function (event, select, icon, position) {
            event.stopPropagation();
            if (icon === null || icon === void 0 ? void 0 : icon.click) {
                icon.click(event, select, icon, position);
            }
            else {
                select.focus();
            }
        };
        NgSelectComponent.prototype.handleFocus = function (event) {
            this.focus.emit(event);
        };
        NgSelectComponent.prototype.handleInput = function (value) {
            this.handleChange(value);
        };
        return NgSelectComponent;
    }(forms.SelectControlValueAccessor));
    NgSelectComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-select',
                    template: "<label class=\"form-label\" *ngIf=\"label\" [for]=\"id\">{{ label }}</label>\n\n<div class=\"input-group\">\n  <button\n    type=\"button\"\n    [disabled]=\"icon?.left?.disabled\"\n    *ngIf=\"icon?.left && !icon?.left?.hidden\"\n    class=\"ng-icon ng-icon__left input-group-text\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    (click)=\"handleClickIcon($event, selectRef, icon.left, 'left')\"\n    [tabIndex]=\"icon?.left?.disabled || !icon?.left?.click ? -1 : 1\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n    [class.shadow-focus]=\"!icon?.left?.disabled && icon?.left?.click\"\n    [class.ng-icon__clickable]=\"!icon?.left?.disabled && icon?.left?.click\"\n  >\n    <i [class]=\"icon?.left?.class\" [ngStyle]=\"{ color: icon?.left?.color }\"></i>\n  </button>\n\n  <select\n    [id]=\"id\"\n    #selectRef\n    (focus)=\"handleFocus($event)\"\n    [attr.readonly]=\"readonly\"\n    [formControl]=\"control\"\n    [class.disabled]=\"disabled\"\n    [class.readonly]=\"readonly\"\n    [compareWith]=\"handleCompareWith.bind(this)\"\n    class=\"form-select shadow-focus\"\n    [tabIndex]=\"control.disabled ? -1 : 1\"\n    [class.form-select-sm]=\"size === 'sm'\"\n    [class.form-select-lg]=\"size === 'lg'\"\n    [class.ng-icon__left]=\"icon?.left && !icon?.left?.hidden\"\n    [class.ng-icon__right]=\"icon?.right && !icon?.right?.hidden\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n  >\n    <ng-container *ngIf=\"position === 'start'\">\n      <option\n        *ngFor=\"let option of _options\"\n        [ngValue]=\"option.value\"\n        [selected]=\"option.value.name === 'ddwada'\"\n      >\n        {{ option.label }}\n      </option>\n    </ng-container>\n\n    <ng-content></ng-content>\n\n    <ng-container *ngIf=\"position === 'end'\">\n      <option *ngFor=\"let option of _options\" [ngValue]=\"option.value\">\n        {{ option.label }}\n      </option>\n    </ng-container>\n  </select>\n\n  <button\n    type=\"button\"\n    [disabled]=\"icon?.right?.disabled\"\n    [tabIndex]=\"icon?.right?.disabled ? -1 : 1\"\n    *ngIf=\"icon?.right && !icon?.right?.hidden\"\n    class=\"ng-icon ng-icon__right input-group-text\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n    (click)=\"handleClickIcon($event, selectRef, icon.right, 'right')\"\n    [class.shadow-focus]=\"!icon?.right?.disabled && icon?.right?.click\"\n    [class.ng-icon__clickable]=\"!icon?.right?.disabled && icon?.right?.click\"\n  >\n    <i\n      [ngStyle]=\"{ color: icon?.right?.color }\"\n      [class]=\"icon?.right?.class\"\n    ></i>\n  </button>\n</div>\n\n<div class=\"ng-helper\">\n  <span\n    class=\"ng-helper__text text-muted\"\n    *ngIf=\"help && !(control.touched && control.invalid)\"\n  >\n    {{ help }}\n  </span>\n\n  <ng-container *ngFor=\"let errorKey of _errorsKeys\">\n    <span\n      class=\"ng-helper__text ng-helper__error\"\n      *ngIf=\"control.touched && control.getError(errorKey)\"\n    >\n      {{ _errors[errorKey] }}\n    </span>\n  </ng-container>\n</div>\n",
                    providers: [PROVIDER_VALUE_ACCESSOR$3]
                },] }
    ];
    NgSelectComponent.ctorParameters = function () { return [
        { type: forms.ControlContainer },
        { type: i0.Renderer2 },
        { type: NgConfigService },
        { type: i0.ElementRef },
        { type: i0.ChangeDetectorRef, decorators: [{ type: i0.SkipSelf }] }
    ]; };
    NgSelectComponent.propDecorators = {
        formControlDirective: [{ type: i0.ViewChild, args: [forms.FormControlDirective, { static: true },] }],
        selectRef: [{ type: i0.ViewChild, args: ['selectRef',] }],
        formControl: [{ type: i0.Input }],
        formControlName: [{ type: i0.Input }],
        id: [{ type: i0.Input }],
        label: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        readonly: [{ type: i0.Input }],
        help: [{ type: i0.Input }],
        required: [{ type: i0.Input }],
        icon: [{ type: i0.Input }],
        propLabel: [{ type: i0.Input }],
        propValue: [{ type: i0.Input }],
        propCompare: [{ type: i0.Input }],
        size: [{ type: i0.Input }],
        position: [{ type: i0.Input }],
        options: [{ type: i0.Input }],
        errors: [{ type: i0.Input }],
        focus: [{ type: i0.Output }]
    };

    var NgSelectModule = /** @class */ (function () {
        function NgSelectModule() {
        }
        return NgSelectModule;
    }());
    NgSelectModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule, NgConfigModule, forms.ReactiveFormsModule],
                    declarations: [NgSelectComponent],
                    exports: [NgSelectComponent],
                },] }
    ];

    var PROVIDER_VALUE_ACCESSOR$2 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgTextAreaComponent; }),
        multi: true,
    };
    var NgTextAreaComponent = /** @class */ (function () {
        function NgTextAreaComponent(_controlContainer, renderer2, ngInputConfig, changeDetectorRef) {
            var _this = this;
            this._controlContainer = _controlContainer;
            this.renderer2 = renderer2;
            this.ngInputConfig = ngInputConfig;
            this.changeDetectorRef = changeDetectorRef;
            this.type = '';
            this.label = '';
            this.readonly = false;
            this.disabled = false;
            this.rows = 3;
            this.cols = 3;
            this.size = 'md';
            this.blur = new i0.EventEmitter();
            this.focus = new i0.EventEmitter();
            this.handleChange = function (_) { };
            this.handleTouched = function () { };
            this.registerOnTouched = function (fn) { return (_this.handleTouched = fn); };
            this.setDisabledState = function (isDisabled) { return (_this.disabled = isDisabled); };
            this.registerOnChange = function (fn) { return (_this.handleChange = fn); };
            this.writeValue = function (value) { };
        }
        Object.defineProperty(NgTextAreaComponent.prototype, "placeholder", {
            set: function (text) {
                var _a;
                this._placeholder = text;
                if (!!text && ((_a = this.textAreaRef) === null || _a === void 0 ? void 0 : _a.nativeElement)) {
                    this.renderer2.setAttribute(this.textAreaRef.nativeElement, 'placeholder', text);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgTextAreaComponent.prototype, "errors", {
            set: function (errors) {
                this._errors = errors;
                this._errorsKeys = Object.keys(errors);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgTextAreaComponent.prototype, "control", {
            get: function () {
                var _a, _b;
                return (this.formControl || ((_b = (_a = this._controlContainer) === null || _a === void 0 ? void 0 : _a.control) === null || _b === void 0 ? void 0 : _b.get(this.formControlName)));
            },
            enumerable: false,
            configurable: true
        });
        NgTextAreaComponent.prototype.ngOnInit = function () {
            var _a, _b;
            if (this.id === undefined) {
                this.id = this.formControlName;
            }
            var value = this.control.value;
            this.control.reset();
            this.required = !!this.control.getError('required');
            this.control.setValue(value);
            var typeConfig = (_a = this.ngInputConfig.typesTextArea) === null || _a === void 0 ? void 0 : _a[this.type.toLowerCase()];
            this.icon = Object.assign({}, (_b = this.ngInputConfig.textarea) === null || _b === void 0 ? void 0 : _b.icon, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.icon, this.icon);
        };
        NgTextAreaComponent.prototype.ngAfterViewInit = function () {
            if (!!this._placeholder) {
                this.placeholder = this._placeholder;
            }
            this.textAreaRef.nativeElement.blur();
            this.control.markAsUntouched();
            this.changeDetectorRef.detectChanges();
        };
        NgTextAreaComponent.prototype.handleClickIcon = function (event, textArea, icon, position) {
            event.stopPropagation();
            if (icon === null || icon === void 0 ? void 0 : icon.click) {
                icon.click(event, textArea, icon, position);
            }
            else {
                textArea.focus();
            }
        };
        NgTextAreaComponent.prototype.handleBlur = function (event) {
            this.handleTouched();
            this.blur.emit(event);
        };
        NgTextAreaComponent.prototype.handleFocus = function (event) {
            this.focus.emit(event);
        };
        return NgTextAreaComponent;
    }());
    NgTextAreaComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-text-area',
                    template: "<label class=\"form-label\" *ngIf=\"label\" [for]=\"id\">{{ label }}</label>\n\n<div class=\"input-group\">\n  <button\n    type=\"button\"\n    [disabled]=\"icon?.left?.disabled\"\n    *ngIf=\"icon?.left && !icon?.left?.hidden\"\n    class=\"ng-icon ng-icon__left input-group-text\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    [tabIndex]=\"icon?.left?.disabled || !icon?.left?.click ? -1 : 1\"\n    (click)=\"handleClickIcon($event, textAreaRef, icon.left, 'left')\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n    [class.shadow-focus]=\"!icon?.left?.disabled && icon?.left?.click\"\n    [class.ng-icon__clickable]=\"!icon?.left?.disabled && icon?.left?.click\"\n  >\n    <i [class]=\"icon?.left?.class\" [ngStyle]=\"{ color: icon?.left?.color }\"></i>\n  </button>\n\n  <textarea\n    [id]=\"id\"\n    #textAreaRef\n    [rows]=\"rows\"\n    [cols]=\"cols\"\n    [readonly]=\"readonly\"\n    [formControl]=\"control\"\n    [attr.maxlength]=\"length\"\n    [class.disabled]=\"disabled\"\n    [class.readonly]=\"readonly\"\n    (blur)=\"handleBlur($event)\"\n    (focus)=\"handleFocus($event)\"\n    class=\"form-control shadow-focus\"\n    [tabIndex]=\"control.disabled ? -1 : 1\"\n    [class.form-control-sm]=\"size === 'sm'\"\n    [class.form-control-lg]=\"size === 'lg'\"\n    [class.ng-icon__left]=\"icon?.left && !icon?.left?.hidden\"\n    [class.ng-icon__right]=\"icon?.right && !icon?.right?.hidden\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n  >\n  <ng-content></ng-content>\n  </textarea>\n\n  <button\n    type=\"button\"\n    [disabled]=\"icon?.right?.disabled\"\n    [tabIndex]=\"icon?.right?.disabled ? -1 : 1\"\n    *ngIf=\"icon?.right && !icon?.right?.hidden\"\n    class=\"ng-icon ng-icon__right input-group-text\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n    (click)=\"handleClickIcon($event, textAreaRef, icon.right, 'right')\"\n    [class.shadow-focus]=\"!icon?.right?.disabled && icon?.right?.click\"\n    [class.ng-icon__clickable]=\"!icon?.right?.disabled && icon?.right?.click\"\n  >\n    <i\n      [ngStyle]=\"{ color: icon?.right?.color }\"\n      [class]=\"icon?.right?.class\"\n    ></i>\n  </button>\n</div>\n\n<div class=\"ng-helper\">\n  <span\n    class=\"ng-helper__text text-muted\"\n    *ngIf=\"help && !(control.touched && control.invalid)\"\n  >\n    {{ help }}\n  </span>\n\n  <ng-container *ngFor=\"let errorKey of _errorsKeys\">\n    <span\n      class=\"ng-helper__text ng-helper__error\"\n      *ngIf=\"control.touched && control.getError(errorKey)\"\n    >\n      {{ _errors[errorKey] }}\n    </span>\n  </ng-container>\n\n  <span class=\"ng-helper__counter text-muted\" *ngIf=\"length\">\n    {{ textAreaRef?.value?.length }}/{{ length }}\n  </span>\n</div>\n",
                    providers: [PROVIDER_VALUE_ACCESSOR$2]
                },] }
    ];
    NgTextAreaComponent.ctorParameters = function () { return [
        { type: forms.ControlContainer },
        { type: i0.Renderer2 },
        { type: NgConfigService },
        { type: i0.ChangeDetectorRef, decorators: [{ type: i0.SkipSelf }] }
    ]; };
    NgTextAreaComponent.propDecorators = {
        formControlDirective: [{ type: i0.ViewChild, args: [forms.FormControlDirective, { static: true },] }],
        textAreaRef: [{ type: i0.ViewChild, args: ['textAreaRef',] }],
        formControl: [{ type: i0.Input }],
        formControlName: [{ type: i0.Input }],
        id: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        label: [{ type: i0.Input }],
        readonly: [{ type: i0.Input }],
        rows: [{ type: i0.Input }],
        cols: [{ type: i0.Input }],
        placeholder: [{ type: i0.Input }],
        help: [{ type: i0.Input }],
        required: [{ type: i0.Input }],
        length: [{ type: i0.Input }],
        icon: [{ type: i0.Input }],
        size: [{ type: i0.Input }],
        errors: [{ type: i0.Input }],
        blur: [{ type: i0.Output }],
        focus: [{ type: i0.Output }]
    };

    var NgTextAreaModule = /** @class */ (function () {
        function NgTextAreaModule() {
        }
        return NgTextAreaModule;
    }());
    NgTextAreaModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule, forms.ReactiveFormsModule],
                    declarations: [NgTextAreaComponent],
                    exports: [NgTextAreaComponent],
                },] }
    ];

    var PROVIDER_VALUE_ACCESSOR$1 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgCheckboxComponent; }),
        multi: true,
    };
    var NgCheckboxComponent = /** @class */ (function (_super) {
        __extends(NgCheckboxComponent, _super);
        function NgCheckboxComponent(controlContainer, renderer2, elementRef) {
            var _this = _super.call(this, renderer2, elementRef) || this;
            _this.controlContainer = controlContainer;
            _this.renderer2 = renderer2;
            _this.elementRef = elementRef;
            _this.indeterminate = false;
            _this.required = false;
            _this.type = 'checkbox';
            return _this;
        }
        Object.defineProperty(NgCheckboxComponent.prototype, "control", {
            get: function () {
                var _a, _b;
                return (this.formControl || ((_b = (_a = this.controlContainer) === null || _a === void 0 ? void 0 : _a.control) === null || _b === void 0 ? void 0 : _b.get(this.formControlName)));
            },
            enumerable: false,
            configurable: true
        });
        NgCheckboxComponent.prototype.ngOnInit = function () {
            if (this.id === undefined) {
                this.id = this.formControlName;
            }
        };
        NgCheckboxComponent.prototype.ngAfterViewInit = function () {
            this.checkboxRef.nativeElement.indeterminate = this.indeterminate;
        };
        return NgCheckboxComponent;
    }(forms.CheckboxControlValueAccessor));
    NgCheckboxComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-checkbox',
                    template: "<div class=\"form-check form-check-inline\">\n  <input\n    [id]=\"id\"\n    #checkboxRef\n    type=\"checkbox\"\n    [formControl]=\"control\"\n    class=\"form-check-input shadow-focus\"\n  />\n  <label [for]=\"id\" class=\"form-check-label\">\n    <ng-content></ng-content>\n  </label>\n</div>\n",
                    providers: [PROVIDER_VALUE_ACCESSOR$1]
                },] }
    ];
    NgCheckboxComponent.ctorParameters = function () { return [
        { type: forms.ControlContainer },
        { type: i0.Renderer2 },
        { type: i0.ElementRef }
    ]; };
    NgCheckboxComponent.propDecorators = {
        formControlDirective: [{ type: i0.ViewChild, args: [forms.FormControlDirective, { static: true },] }],
        checkboxRef: [{ type: i0.ViewChild, args: ['checkboxRef',] }],
        formControl: [{ type: i0.Input }],
        formControlName: [{ type: i0.Input }],
        id: [{ type: i0.Input }],
        readonly: [{ type: i0.Input }],
        indeterminate: [{ type: i0.Input }],
        required: [{ type: i0.Input }],
        type: [{ type: i0.Input }]
    };

    var NgCheckboxModule = /** @class */ (function () {
        function NgCheckboxModule() {
        }
        return NgCheckboxModule;
    }());
    NgCheckboxModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule, forms.ReactiveFormsModule],
                    declarations: [NgCheckboxComponent],
                    exports: [NgCheckboxComponent],
                },] }
    ];

    var PROVIDER_VALUE_ACCESSOR = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgSwitchComponent; }),
        multi: true,
    };
    var NgSwitchComponent = /** @class */ (function (_super) {
        __extends(NgSwitchComponent, _super);
        function NgSwitchComponent(controlContainer, renderer2, elementRef) {
            var _this = _super.call(this, renderer2, elementRef) || this;
            _this.controlContainer = controlContainer;
            _this.renderer2 = renderer2;
            _this.elementRef = elementRef;
            _this.indeterminate = false;
            _this.required = false;
            _this.type = 'checkbox';
            return _this;
        }
        Object.defineProperty(NgSwitchComponent.prototype, "control", {
            get: function () {
                var _a, _b;
                return (this.formControl || ((_b = (_a = this.controlContainer) === null || _a === void 0 ? void 0 : _a.control) === null || _b === void 0 ? void 0 : _b.get(this.formControlName)));
            },
            enumerable: false,
            configurable: true
        });
        NgSwitchComponent.prototype.ngOnInit = function () {
            if (this.id === undefined) {
                this.id = this.formControlName;
            }
        };
        NgSwitchComponent.prototype.ngAfterViewInit = function () {
            this.checkboxRef.nativeElement.indeterminate = this.indeterminate;
        };
        return NgSwitchComponent;
    }(forms.CheckboxControlValueAccessor));
    NgSwitchComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-switch',
                    template: "<div class=\"form-check form-switch form-check-inline\">\n  <input\n    [id]=\"id\"\n    #checkboxRef\n    type=\"checkbox\"\n    [formControl]=\"control\"\n    class=\"form-check-input shadow-focus\"\n  />\n  <label [for]=\"id\" class=\"form-check-label\">\n    <ng-content></ng-content>\n  </label>\n</div>\n",
                    providers: [PROVIDER_VALUE_ACCESSOR]
                },] }
    ];
    NgSwitchComponent.ctorParameters = function () { return [
        { type: forms.ControlContainer },
        { type: i0.Renderer2 },
        { type: i0.ElementRef }
    ]; };
    NgSwitchComponent.propDecorators = {
        formControlDirective: [{ type: i0.ViewChild, args: [forms.FormControlDirective, { static: true },] }],
        checkboxRef: [{ type: i0.ViewChild, args: ['checkboxRef',] }],
        formControl: [{ type: i0.Input }],
        formControlName: [{ type: i0.Input }],
        id: [{ type: i0.Input }],
        readonly: [{ type: i0.Input }],
        indeterminate: [{ type: i0.Input }],
        required: [{ type: i0.Input }],
        type: [{ type: i0.Input }]
    };

    var NgSwitchModule = /** @class */ (function () {
        function NgSwitchModule() {
        }
        return NgSwitchModule;
    }());
    NgSwitchModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule, forms.ReactiveFormsModule],
                    declarations: [NgSwitchComponent],
                    exports: [NgSwitchComponent],
                },] }
    ];

    /*
     * Public API Surface of ng-fields
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.FOR_ROOT_OPTIONS_TOKEN = FOR_ROOT_OPTIONS_TOKEN;
    exports.NgAutocompleteModule = NgAutocompleteModule;
    exports.NgCheckboxModule = NgCheckboxModule;
    exports.NgInputModule = NgInputModule;
    exports.NgInputsBootstrap = NgInputsBootstrap;
    exports.NgMaskPipeModule = NgMaskPipeModule;
    exports.NgMasksDirectivesModule = NgMasksDirectivesModule;
    exports.NgMasksServicesModule = NgMasksServicesModule;
    exports.NgSelectModule = NgSelectModule;
    exports.NgSwitchModule = NgSwitchModule;
    exports.NgTextAreaModule = NgTextAreaModule;
    exports.NgUtilsDirectiveModule = NgUtilsDirectiveModule;
    exports.provideMyServiceOptions = provideMyServiceOptions;
    exports.ɵa = NgConfigModule;
    exports.ɵb = NgConfigService;
    exports.ɵba = NgSelectComponent;
    exports.ɵbb = PROVIDER_VALUE_ACCESSOR$2;
    exports.ɵbc = NgTextAreaComponent;
    exports.ɵbd = PROVIDER_VALUE_ACCESSOR$1;
    exports.ɵbe = NgCheckboxComponent;
    exports.ɵbf = PROVIDER_VALUE_ACCESSOR;
    exports.ɵbg = NgSwitchComponent;
    exports.ɵc = NgColumnsDirective;
    exports.ɵd = PROVIDER_VALUE_ACCESSOR$8;
    exports.ɵe = NgMaskCurrencyDirective;
    exports.ɵf = PROVIDER_VALUE_ACCESSOR$6;
    exports.ɵg = NgMaskDirective;
    exports.ɵh = PROVIDER_VALUE_ACCESSOR$7;
    exports.ɵi = NgMaskPercentDirective;
    exports.ɵj = PROVIDER_VALUE_ACCESSOR$9;
    exports.ɵk = NgMaskAmountDirective;
    exports.ɵl = NgMaskAmountService;
    exports.ɵm = NgMaskCurrencyService;
    exports.ɵn = NgMaskPercentService;
    exports.ɵo = NgMaskPipe;
    exports.ɵp = NgMaskService;
    exports.ɵq = NgMaskAmountPipe;
    exports.ɵr = NgMaskPercentPipe;
    exports.ɵs = NgMaskCurrencyPipe;
    exports.ɵt = PROVIDER_VALUE_ACCESSOR$5;
    exports.ɵu = NgAutocompleteComponent;
    exports.ɵv = NgUtilsServiceModule;
    exports.ɵw = NgFormatDateByTypeService;
    exports.ɵx = PROVIDER_VALUE_ACCESSOR$4;
    exports.ɵy = NgInputComponent;
    exports.ɵz = PROVIDER_VALUE_ACCESSOR$3;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=douglas-serena-ng-inputs-bootstrap.umd.js.map
