import { ChangeDetectorRef, ElementRef, EventEmitter, OnInit, Provider, Renderer2 } from '@angular/core';
import { ControlContainer, ControlValueAccessor, FormControl, FormControlDirective } from '@angular/forms';
import { NgIconConfig, NgIconPositionsConfig } from '../../interfaces/ng-icon-config.interface';
import { NgConfigService } from '../../config/ng-config.service';
export declare const PROVIDER_VALUE_ACCESSOR: Provider;
export declare class NgTextAreaComponent implements OnInit, ControlValueAccessor {
    private _controlContainer;
    private renderer2;
    private ngInputConfig;
    private changeDetectorRef;
    formControlDirective: FormControlDirective;
    textAreaRef: ElementRef<HTMLTextAreaElement>;
    formControl: FormControl;
    formControlName: string;
    id: string;
    type: string;
    label: string;
    readonly: boolean;
    disabled: boolean;
    rows: number | string;
    cols: number | string;
    set placeholder(text: string | null);
    _placeholder?: string | null;
    help: string;
    required: boolean;
    length: string | number;
    icon: NgIconPositionsConfig;
    size: 'lg' | 'md' | 'sm';
    set errors(errors: {
        [key: string]: string;
    });
    _errors: {
        [key: string]: string;
    };
    _errorsKeys: string[];
    get control(): FormControl;
    constructor(_controlContainer: ControlContainer, renderer2: Renderer2, ngInputConfig: NgConfigService, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    handleClickIcon(event: Event, textArea: HTMLTextAreaElement, icon: NgIconConfig | undefined, position: 'left' | 'right'): void;
    blur: EventEmitter<any>;
    handleBlur(event: FocusEvent): void;
    focus: EventEmitter<any>;
    handleFocus(event: FocusEvent): void;
    handleChange: (_: any) => void;
    handleTouched: () => void;
    registerOnTouched: (fn: () => void) => () => void;
    setDisabledState: (isDisabled: boolean) => boolean;
    registerOnChange: (fn: (_: any) => void) => (_: any) => void;
    writeValue: (value: number | string) => void;
}
