import { ChangeDetectorRef, ElementRef, Renderer2, OnInit, Provider, EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { NgMaskConfig } from '../../interfaces/ng-mask-config.interface';
export declare const PROVIDER_VALUE_ACCESSOR: Provider;
export declare class NgMaskCurrencyDirective implements OnInit, ControlValueAccessor {
    private elementRef;
    private renderer2;
    private changeDetectorRef;
    private _inputRef;
    private _instanceSimpleMaskMoneyRef;
    private _locale;
    private _isCurrency;
    private _config;
    set locale(symbolOrLocale: {
        currency: string;
    } | string);
    set ngMaskCurrency(config: NgMaskConfig | string);
    type: string;
    value: EventEmitter<any>;
    constructor(elementRef: ElementRef<HTMLInputElement>, renderer2: Renderer2, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    createMask(): void;
    onTouched: () => void;
    onFocus: () => void;
    eventTime: any;
    onInput(event?: KeyboardEvent): void;
    validRequired(value: string | number): any;
    onChange: (_: any) => void;
    registerOnTouched: (fn: () => void) => () => void;
    setDisabledState: (isDisabled: boolean) => void;
    registerOnChange: (fn: (_: any) => void) => void;
    writeValue(value: number | string): void;
}
